/*
 * $Id: main.h,v 1.1.1.1.4.2 2005/08/19 15:48:00 dahms Exp $
 */

#ifndef _MAIN_H

#include <GL/gl.h>
#include <gtk/gtk.h>
#include <g3d/g3d.h>

#define G3D_FLAG_GL_SPECULAR        (1L << 0)
#define G3D_FLAG_GL_SHININESS       (1L << 1)
#define G3D_FLAG_GL_ALLTWOSIDE      (1L << 2)
#define G3D_FLAG_GL_TEXTURES        (1L << 3)

typedef struct {
	G3DContext *g3dcontext;
	G3DModel *model;
	gchar *filename;

	/* GL stuff */
	GLfloat quat[4];
	GLfloat zoom;
	GLfloat aspect;
	GLfloat bgcolor[4];
	guint32 glflags;

	/* mouse */
	struct {
		gint32 beginx, beginy;
	} mouse;

	/* interface */
	struct {
		GtkWidget *window;
		GtkWidget *infowin;
		GtkWidget *opendialog;
		/* model tab */
		struct {
			GtkWidget *tree;
		} modeltab;
		/* plugin tab */
		struct {
			GtkWidget *label_desc;
			GtkWidget *label_exts;
		} plugintab;

		GtkWidget *glarea;
		GtkWidget *statushbox;
		GtkWidget *progressbar;
		gboolean show_statusbar;
	} interface;

} G3DViewer;

#define _MAIN_H

#endif
