#include <g3d/g3d.h>

#include "main.h"
#include "texture.h"
#include "infowin.h"

gboolean model_load(G3DViewer *viewer)
{
	G3DModel *model;
	gchar *title;
	gboolean retval = FALSE;

	/* free old model */
	model = viewer->model;
	viewer->model = NULL;
	if(model)
		g3d_model_free(model);

	model = g3d_model_load(viewer->g3dcontext, viewer->filename);
	if(model)
	{
		viewer->model = model;
		texture_load_all_textures(viewer->model);
		retval = TRUE;
	}

	/* update model information */
	infowin_modeltab_fill(viewer);

	/* update window title */
	title = g_strdup_printf("g3dviewer%s%s",
		viewer->model ? " - " : "",
		viewer->filename ? viewer->filename : "");
	gtk_window_set_title(GTK_WINDOW(viewer->interface.window), title);
	g_free(title);

	return retval;
}
